package net.shadowfacts.cacao.util

import net.minecraft.util.Identifier

/**
 * A helper class that represents a texture.
 *
 * @author shadowfacts
 * @param location The identifier representing the resource-pack location of the texture image.
 * @param u The X coordinate in pixels of where the texture starts within the image.
 * @param v The Y coordinate in pixels of where the texture starts within the image.
 * @param width The width in pixels of the entire image.
 * @param height The height in pixels of the entire image.
 */
data class Texture(val location: Identifier, val u: Int, val v: Int, val width: Int = 256, val height: Int = 256)
